# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [9.4.17] - 2026-08-10 (with data-quality 9.2.16)

## [9.4.16] - 2026-07-02 (with data-quality 9.2.16)
### Fixed
- fix([QTDQ-1750](https://qlik-dev.atlassian.net/browse/QTDQ-1750)): Don't return original character after masking with 'replaceCharacter'

### Security
- fix([QTDQ-1738](https://qlik-dev.atlassian.net/browse/QTDQ-1738)): upgrade 'log4j-core' to 2.25.4
- fix([QTDQ-1743](https://qlik-dev.atlassian.net/browse/QTDQ-1743)): Upgrade jackson to 2.22.0
- fix([QTDQ-1737](https://qlik-dev.atlassian.net/browse/QTDQ-1737)): upgrade commons-configuration2 to 2.15.0

## [9.4.15] - 2026-04-15 (with data-quality 9.2.15)

## [9.4.14] - 2026-03-09 (with data-quality 9.2.14)
### Security
- fix([QTDQ-842](https://qlik-dev.atlassian.net/browse/QTDQ-842)): upgrade 'log4j-core' to 2.25.3

## [9.4.13] - 2026-01-12 (with data-quality 9.2.13)

## [9.4.12] - 2025-12-09 (with data-quality 9.2.13-SNAPSHOT)

## [9.4.11] - 2025-10-27 (with data-quality 9.2.12)
### Security
- fix([QTDQ-910](https://qlik-dev.atlassian.net/browse/QTDQ-910)): upgrade daikon to 7.1.28
- fix([QTDQ-944](https://qlik-dev.atlassian.net/browse/QTDQ-944)): upgrade to commons-io-2.20.0,commons-compress-1.28.0,commons-lang3-3.18.0,commons-codec-1.19.0

## [9.4.10] - 2025-07-11 (with data-quality 9.2.10)
### Security
- fix([QTDQ-819](https://qlik-dev.atlassian.net/browse/QTDQ-819)): upgrade daikon to 7.1.27
- fix([QTDQ-822](https://qlik-dev.atlassian.net/browse/QTDQ-822)): upgrade commons-Beanutils from 1.9.4 to 1.11.0

## [9.4.9] - 2025-05-13 (with data-quality 9.2.9)

## [9.4.8] - 2024-11-13 (with data-quality 9.2.8)
### Security
- fix([TDQ-22225](https://jira.talendforge.org/browse/TDQ-22225)): fix CVE upgrade commons-io from 2.8.0 to 2.16.1
- fix([TDQ-22225](https://jira.talendforge.org/browse/TDQ-22225)): upgrade to bcprov-jdk18on 1.78.1
- fix([TDQ-22225](https://jira.talendforge.org/browse/TDQ-22225)): set commons.lang3 to 3.13.0 same with studio

## [9.4.7] - 2024-09-12 (with data-quality 9.2.6)

## [9.4.6] - 2024-08-15 (with data-quality 9.2.6)

## [9.4.5] - 2024-06-11 (with data-quality 9.2.5)
### Security
- fix([TDQ-21883](https://jira.talendforge.org/browse/TDQ-21883)): upgrade commons-compress to 1.26.0, commons-configuration2 to 2.10.1

## [9.4.4] - 2024-05-14 (with data-quality 9.2.4)

## [9.4.2] - 2024-04-08 (with data-quality 9.2.2)
### Security
- fix([TDQ-21757](https://jira.talendforge.org/browse/TDQ-21757)): Upgrade jackson from 2.14.3 to 2.16.0

## [9.4.1] - 2023-12-01 (with data-quality 9.2.1)
### Changed
- fix([TDQ-21649](https://jira.talendforge.org/browse/TDQ-21649)) : change Require-Bundle:org.slf4j.api to Import-Package:org.slf4j

## [9.3.25] - 2023-11-21 (with data-quality 9.1.16)

## [9.3.24] - 2023-11-09 (with data-quality 9.1.16)

## [9.3.23] - 2023-09-29 (with data-quality 9.1.16)

## [9.3.22] - 2023-09-22 (with data-quality 9.1.16)
### Security
- fix([TDQ-21398](https://jira.talendforge.org/browse/TDQ-21398)): Upgrade jackson to 2.14.3
- fix([TDQ-21323](https://jira.talendforge.org/browse/TDQ-21323)): upgrade daikon to 7.1.16

## [9.3.21] - 2023-09-07 (with data-quality 9.1.14)
### Fixed
- fix([TDQ-21236](https://jira.talendforge.org/browse/TDQ-21236)): Issue of semantic analysis

## [9.3.20] - 2023-08-09 (with data-quality 9.1.14)
### Changed
- fix([TDQ-21323](https://jira.talendforge.org/browse/TDQ-21323)): revert daikon to 7.0.5

## [9.3.19] - 2023-08-01 (with data-quality 9.1.15)
### Security
- fix([TDQ-21323](https://jira.talendforge.org/browse/TDQ-21323)): upgrade daikon to 7.1.16

## [9.3.18] - 2023-07-12 (with data-quality 9.1.14)

## [9.3.17] - 2023-05-11 (with data-quality 9.1.13)

## [9.3.16] - 2023-04-13 (with data-quality 9.1.12)

## [9.3.15] - 2023-02-09 (with data-quality 9.1.12)

## [9.3.14] - 2023-01-03 (with data-quality 9.1.12)
### Security
- fix([TDQ-20585](https://jira.talendforge.org/browse/TDQ-20585)): upgrade daikon to 7.0.5

## [9.3.13] - 2022-12-14 (with data-quality 9.1.11)
### Security
- fix([TDQ-20851](https://jira.talendforge.org/browse/TDQ-20851)): Upgrade slf4j to 1.7.34

## [9.3.12] - 2022-11-10 (with data-quality 9.1.10)
### Security
- fix([TDQ-20772](https://jira.talendforge.org/browse/TDQ-20772)): Fix jackson-databind issues (to 2.14.0-rc2)
- fix([TDQ-20792](https://jira.talendforge.org/browse/TDQ-20792)): Fix all jackson jar(to 2.13.4)
- fix([TDQ-20799](https://jira.talendforge.org/browse/TDQ-20799)): Fix org.apache.commons:commons-text:1.8,1.9(to 1.10.0)

## [9.3.11] - 2022-10-13 (with data-quality 9.1.9)

## [9.3.10] - 2022-09-15 (with data-quality 9.1.8)
### Fixed
- fix([TDQ-19987](https://jira.talendforge.org/browse/TDQ-19987)): Fix Sonar blocker issues on DQEE

## [9.3.9] - 2022-08-11 (with data-quality 9.1.7)
### Changed
- chore([TDQ-20569](https://jira.talendforge.org/browse/TDQ-20569)): migrate CipherSources.blowfish() from Daikon to DQ lib and upgrade daikon to 6.8.7
### Security
- fix([TDQ-20580](https://jira.talendforge.org/browse/TDQ-20580)): Fix Apache Commons Configuration (to 2.8.0)

## [9.3.8] - 2022-07-12 (with data-quality 9.1.6-SNAPSHOT)
### Changed
- perf([TDQ-20553](https://jira.talendforge.org/browse/TDQ-20553)): Improve the performance of FieldDate
- perf([TDQ-20554](https://jira.talendforge.org/browse/TDQ-20554)): Improve the performance of AmericanCheckAlgorithm
- perf([TDQ-20555](https://jira.talendforge.org/browse/TDQ-20555)): Improve the performance of Modulo 97
- perf([TDQ-20556](https://jira.talendforge.org/browse/TDQ-20556)): Improve the performance of GenerateSsnChn
### Fixed
- fix([TDQ-19987](https://jira.talendforge.org/browse/TDQ-19987)): Fix Sonar blocker issues on DQEE
### Security
- fix([TDQ-20481](https://jira.talendforge.org/browse/TDQ-20481)): upgrade daikon to 6.8.2

## [9.3.7] - 2022-06-15 (with data-quality 9.1.6-SNAPSHOT)

## [9.3.6] - 2022-05-12 (with data-quality 9.1.5)
### Fixed
- fix([TDQ-20297](https://jira.talendforge.org/browse/TDQ-20297)): Fix 2 functions of Keep to use new param AlgoVersion
### Security
- fix([TDQ-20210](https://jira.talendforge.org/browse/TDQ-20210)): Fix jackson-databind issues (to 2.13.2.2)

## [9.3.5] - 2022-04-14 (with data-quality 9.1.4)
### Changed
wi([TDQ-20143](https://jira.talendforge.org/browse/TDQ-20143)): Increase nb of iterations for password derivations functions
fix([TDQ-20209](https://jira.talendforge.org/browse/TDQ-20209)): Streaming job with invalid tweak not unmasking to original

## [9.3.4] - 2022-03-04 (with data-quality 9.1.3)
### Added
- feat([TDQ-20144](https://jira.talendforge.org/browse/TDQ-20144)): Enable the use of a cryptoKey in masking and encryption functions
### Changed
- TDQ(14370): Improve masking performances by not using BigInteger whenever possible 
### Security
- fix([TDQ-20023](https://jira.talendforge.org/browse/TDQ-20023)): Fix log4j issues (from log4j 1.x to log4j 2)

## [9.3.3] - 2022-02-04 (with data-quality 9.1.2)

## [9.3.2] - 2022-02-03 (with data-quality 9.1.2-SNAPSHOT)

## [9.3.1] - 2022-01-07 (with data-quality 9.1.1)
### Changed
- fix([TDQ-19163](https://jira.talendforge.org/browse/TDQ-19163)): fix some unsupported data type for tDatamasking
### Security
- fix([TDQ-20024](https://jira.talendforge.org/browse/TDQ-20024)): upgrade 'log4j-core' to 2.17.1

## [9.3.0] - 2021-12-15 (with data-quality 9.1.0)
### Security
- fix([TDQ-19973](https://jira.talendforge.org/browse/TDQ-19973)): upgrade 'log4j-core' to 2.16.0

## [9.2.7] - 2021-10-19 (with data-quality 9.0.2)

## [9.2.6] - 2021-10-15 (with data-quality 9.0.2)

## [9.2.5] - 2021-10-07 (with data-quality 9.0.1)

## [9.2.4] - 2021-09-21 (with data-quality 9.0.0)
### Fixed
- fix([TDQ-19372](https://jira.talendforge.org/browse/TDQ-19372)) tDataUnmasking: 'Unmask French SSN number' doesn't work: Add the validation check before masking SSN.
### Security
- fix([TDQ-19311](https://jira.talendforge.org/browse/TDQ-19311)): Fix Apache Commons IO issues (to 2.8.0)

## [9.2.3] - 2021-06-02 (with data-quality 9.0.0)
### Added
- feature([TDQ-18829](https://jira.talendforge.org/browse/TDQ-18829)): tDataMasking with dynamic schemas
### Fixed
- fix([TDQ-19101](https://jira.talendforge.org/browse/TDQ-19101)): handle not supported types for Alphabet.
- fix([TDQ-19083](https://jira.talendforge.org/browse/TDQ-19083)): Fix extra parameter doesn't work for generate sequence function
### Security
- fix([TDQ-19066](https://jira.talendforge.org/browse/TDQ-19066)): Fix jackson-databind issues
- fix([TDQ-19073](https://jira.talendforge.org/browse/TDQ-19073)): Fix JUnit issue
- fix([TDQ-19045](https://jira.talendforge.org/browse/TDQ-19045)): Update Jackson Databind to 2.11.4
- fix([TDQ-19124](https://jira.talendforge.org/browse/TDQ-19124)): Upgrade Daikon to 5.3.0

## [9.2.2] - 2021-01-07 (with data-quality 8.3.1)
### Security
- fix([TDQ-18897](https://jira.talendforge.org/browse/TDQ-18897)): Fix org.apache.httpcomponents:httpclient issue

## [9.2.1] - 2020-12-02 (with data-quality 8.3.1)
### Fixed
- fix([TDQ-18549](https://jira.talendforge.org/browse/TDQ-18549)): backport missing commits of IBAN masking refinement

## [9.2.0] - 2020-11-26 (with data-quality 8.3.1)
### Added
 - feature([TDQ-18573](https://jira.talendforge.org/browse/TDQ-18573)): handle national check digits for IBAN	
 - feature([TDQ-18615](https://jira.talendforge.org/browse/TDQ-18615)): plug the national checks for IBAN in "Mask account number and keep original country"
 - feature([TDQ-18544](https://jira.talendforge.org/browse/TDQ-18544)): add "Mask account number and keep original country and bank code"
 - feature([TDQ-18735](https://jira.talendforge.org/browse/TDQ-18735)): add "Unmask account number and keep original country and bank code"
### Fixed
 - fix([TDQ-18725](https://jira.talendforge.org/browse/TDQ-18725)): make repeatable masking work for IBANs

## [9.1.0] - 2020-11-18 (with data-quality 8.3.1)
### Fixed
- fix([TDQ-18614](https://jira.talendforge.org/browse/TDQ-18614)): Return an IBAN of the corresponding country code for invalid IBANs
### Security
- fix([TDQ-17694](https://jira.talendforge.org/browse/TDQ-17694)): Fix Jackson Data Mapper Issues
- fix([TDQ-18385](https://jira.talendforge.org/browse/TDQ-18385)): Fix Apache Common Codec issues

## [9.0.0] - 2020-10-19 (with data-quality )

## [8.3.1] - 2020-10-07 (with data-quality 8.3.0)
### Fixed
- fix([TDQ-18613](https://jira.talendforge.org/browse/TDQ-18613)): function "Generate account number and keep country" not working for some countries
- fix([TDQ-18550](https://jira.talendforge.org/browse/TDQ-18550)): generating IBANs must handle alphabetical characters
- fix([TDQ-18730](https://jira.talendforge.org/browse/TDQ-18730)): tDataMasking Generate account number and keep original country job run failed when US data contains space at the end
### Security
- Fix([TDQ-18388](https://jira.talendforge.org/browse/TDQ-18388)): Fix Apache Hadoop MapReduce Core issue
- Fix([TDQ-18405](https://jira.talendforge.org/browse/TDQ-18405)): Fix Spark Project Core issues

## [8.3.0] - 2020-07-16 (with data-quality 8.3.0)
### Changed
- workItem([TDQ-18429](https://jira.talendforge.org/browse/TDQ-18429)): Upgrade versions of google phone library from 8.10.5 to 8.12.3

## [8.2.0] - 2020-06-18 (with data-quality 8.2.0)
### Security
- fix([TDQ-18383](https://jira.talendforge.org/browse/TDQ-18383)) Upgrade to log4j to log4j-core 2.13.2

## [8.1.0] - 2020-02-18 (with data-quality 8.0.0)

## [8.0.0] - 2020-02-09 (with data-quality 8.0.0)
### Added
- feature([TDQ-17635](https://jira.talendforge.org/browse/TDQ-17635)): A user should be able to encrypt values with tweaks when using FPE
### Changed
- workitem([TDQ-17596](https://jira.talendforge.org/browse/TDQ-17596)) : Improve documentation of FPE API + minor changes
### Fixed
- workitem([TDQ-17788](https://jira.talendforge.org/browse/TDQ-17788)) : Reduce Technical Debt
- fix([TDQ-17982](https://jira.talendforge.org/browse/TDQ-17982)) : Fix incorrect use of tweaks in tPatternMasking, SSN Masking and US Phone masking

## [7.4.3] - 2019-12-04 (with data-quality 7.4.0)
### Added
- chore([TDQ-17710](https://jira.talendforge.org/browse/TDQ-17710)): Adopt the "Keep a Changelog" format for changelogs
- feat([TDQ-17147](https://jira.talendforge.org/browse/TDQ-17147)): Support FPE for account number functions
### Fixed
- fix([TDQ-17706](https://jira.talendforge.org/browse/TDQ-17706)): fix wrong check digit computation for French bank accounts
